#include <iostream>
#include <set>
#include "itemarray.hh"

Itemarray *intersection(const Itemarray* in1, const Itemarray* in2) {
  Itemarray *out=new Itemarray(in1->n<in2->n ? in1->n : in2->n);

  int j=0;
  for(int i1=0, i2=0; i1<in1->n && i2<in2->n;)
    if(in1->items[i1]==in2->items[i2]) 
      { out->items[j]=in1->items[i1]; ++i1; ++i2; ++j; }
    else if(in1->items[i1]>in2->items[i2]) { ++i2; }
    else { ++i1; }


  out->n=j;

  return out;
}

ostream& operator<<(ostream& os, const pair<Itemarray*,int>& out) {
  for(int i=0; i<(out.first)->n; ++i) os << (out.first)->items[i] << " ";
  return os << "(" << out.second << ")";
}

istream& operator>>(istream& is, pair<Itemarray*,int>& in) {
  in.second=1;

  set<Item> s;

  char c;
  while(!is.eof() && (c=is.get())!='\n') {
    if(c=='(') { is >> in.second; is.get(); } else if(c>='0' && c<='9') {
      is.unget();
      Item item; is >> item;
      s.insert(item);
    }
  }

  if(!is.eof()) { is.get(); is.unget(); }

  Itemarray* out=new Itemarray(s.size());

  int i=0;
  for(set<Item>::const_iterator j=s.begin(); j!=s.end(); ++j)
    out->items[i++]=*j;

  in.first=out;

  return is;
}


