#include <iostream>
#include "itemarraycollection.hh"

inline void ItemarrayMap::insert(pair<Itemarray*,int>& in) { 
  if(forbidden.find(in.first)==forbidden.end()) itemarrays.insert(in); 
  else delete in.first;
}

inline void ItemarrayMap::remove(iterator& i) { 
  forbidden.insert((*i).first);
  iterator j=i; ++i; itemarrays.erase(j); 
}

inline void ItemarrayMap::replaceIfGreater(pair<Itemarray*,int>& in) {
  iterator j=find(in.first);
  if(j==end()) insert(in);
  else { delete in.first; if((*j).second<in.second) (*j).second=in.second; }
}

void ItemarrayMap::intersect(const pair<Itemarray*,int>* in) {
  pair<Itemarray*,int> p(in->first,in->second);

  for(const_iterator i=begin(); i!=end(); ++i) {
    Itemarray *out=intersection((in->first),((*i).first));
    p.first=out; p.second=in->second+(*i).second;
    replaceIfGreater(p);
  }

  Itemarray *out=new Itemarray((in->first)->n);
  for(int i=0; i<out->n; ++i) out->items[i]=(in->first)->items[i];

  p.first=out; p.second=in->second;

  replaceIfGreater(p);
}

#ifdef IN_MEMORY
void ItemarrayMap::prune(ItemarrayMemoryInput& in) {
#else
void ItemarrayMap::prune(ItemarrayFileInput& in) {
#endif
  pair<Itemarray*,int> p((Itemarray*)0,0);

  for(iterator i=begin(); i!=end();) {
    int minsupp=in.minsupp-(*i).second;

    if(minsupp>in.remsupp) { remove(i); continue; }      

    if((*i).second>in.maxsupp) { remove(i); continue; }

    if(((*i).first)->n==0) {++i; continue; }

    int upper;
    upper=in.remsupps[((*i).first)->items[0]];
    
    for(int j=1; j<((*i).first)->n; ++j) {
      int remsupp=in.remsupps[((*i).first)->items[j]];
      if(upper<remsupp) upper=remsupp;
      //else if(lower>remsupp) lower=remsupp;
    }
    
    if(minsupp>upper) { remove(i); continue; }

    /*
    if(minsupp>lower) {
      Itemarray *out=new Itemarray(((*i).first)->n);
      
      int k=0;
      for(int j=0; j<((*i).first)->n; ++j) {
	if(minsupp<=in.remsupps[((*i).first)->items[j]]) {
	  out->items[k]=((*i).first)->items[j]; ++k; 
	}
      }
      out->n=k;
      
      p.first=out; p.second=(*i).second;

      replaceIfGreater(p);
      
      remove(i); continue;
    }
    */
    ++i;
  }
}

ostream& operator<<(ostream& os, const ItemarrayMap& out) {
  for(ItemarrayMap::const_iterator i=out.begin(); i!=out.end(); ++i) 
    os << *i << endl;

  return os;
}
