#include <set>
#include <map>
#include "itemarray.hh"
#include "itemarrayinput.hh"

class ItemarrayMap {
  map<Itemarray*,int,CardLex> itemarrays;
  set<Itemarray*,CardLex> forbidden;

public:
  typedef map<Itemarray*,int,CardLex>::iterator iterator;
  typedef map<Itemarray*,int,CardLex>::const_iterator const_iterator;

  ItemarrayMap() : itemarrays(), forbidden() { }

  void intersect(const pair<Itemarray*,int>*);
#ifdef IN_MEMORY
  void prune(ItemarrayMemoryInput&);
#else
  void prune(ItemarrayFileInput&);
#endif
  iterator find(Itemarray* in) { return itemarrays.find(in); }
  void insert(pair<Itemarray*,int>&);
  void remove(iterator&);
  void replaceIfGreater(pair<Itemarray*,int>&);

  int size() const { return itemarrays.size(); }
  int forbidden_size() const { return forbidden.size(); }

  iterator begin() { return itemarrays.begin(); }
  iterator end() { return itemarrays.end(); }

  const_iterator begin() const { return itemarrays.begin(); }
  const_iterator end() const { return itemarrays.end(); }
};

ostream& operator<<(ostream& os, const ItemarrayMap& out);
